/*
 * compile_by_version.sql
 * Chapter 1, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script demonstrates a 10gR2 new feature - Conditional Compilation
 */

SET SERVEROUTPUT ON PAGES 9999

spool compile_by_version.log

CREATE OR REPLACE PROCEDURE compile_by_version
IS

BEGIN
   $IF DBMS_DB_VERSION.VER_LE_10_2
   $THEN
      DBMS_OUTPUT.PUT_LINE('10.2 and under');
   $ELSIF DBMS_DB_VERSION.VER_LE_10_1
   $THEN
      DBMS_OUTPUT.PUT_LINE('10.1 and under');
   $ELSE
      DBMS_OUTPUT.PUT_LINE('Not 10g');
   $END

END;
/


PROMPT
PROMPT * * *
PROMPT * * * Select the source code from USER_SOURCE
PROMPT * * *
PROMPT

SELECT TEXT 
FROM USER_SOURCE
WHERE NAME = 'COMPILE_BY_VERSION';


PROMPT
PROMPT * * *
PROMPT * * * View the post-processed source
PROMPT * * *
PROMPT

BEGIN
   DBMS_PREPROCESSOR.PRINT_POST_PROCESSED_SOURCE (
      'PROCEDURE', 
      'PLSQL', 
      'COMPILE_BY_VERSION');
END;
/

spool off
