/*
 * predictive_analytics.sql
 * Chapter 1, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script demonstrates a 10gR2 new feature - Predictive Analytics
 */

spool predictive_analytics.log

EXEC clean_schema.tables

CREATE TABLE assessment (
                         student_id NUMBER(10) PRIMARY KEY,
                         performance NUMBER(10),
                         gender VARCHAR2(10) NOT NULL,
                         ethnicity NUMBER(10) NOT NULL,
                         age NUMBER(10) NOT NULL);

CREATE SEQUENCE assessment_seq
START WITH 1
INCREMENT BY 1
NOCACHE;

CREATE OR REPLACE TRIGGER assessment_trig
   BEFORE INSERT
   ON assessment
   FOR EACH ROW
BEGIN
   SELECT assessment_seq.NEXTVAL
     INTO :NEW.STUDENT_ID
     FROM DUAL;
END;
/

INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 2, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 8);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 2, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 8);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 2, 'M', 5, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 2, 'M', 2, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 2, 'M', 5, 8);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 2, 9);
INSERT INTO assessment
VALUES (NULL, 2, 'M', 4, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 2, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 3, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 2, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 4, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 5, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 8);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'M', 5, 10);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, 3, 'F', 3, 9);
INSERT INTO assessment
VALUES (NULL, 1, 'M', 5, 10);

INSERT INTO assessment
SELECT * FROM assessment;

INSERT INTO assessment
SELECT * FROM assessment;

INSERT INTO assessment
SELECT * FROM assessment;

INSERT INTO assessment
SELECT * FROM assessment;

COMMIT;

PROMPT ***
PROMPT *** Using DBMS_PREDICTIVE_ANALYTICS.EXPLAIN
PROMPT ***  Print the ASSESSMENT table's columns
PROMPT ***  and their correlation to PERFORMANCE
PROMPT ***
PROMPT

BEGIN
   DBMS_PREDICTIVE_ANALYTICS.EXPLAIN (
      'ASSESSMENT',
      'PERFORMANCE',
      'ASSESSMENT_ANALYSIS');
END;
/

SET PAGES 9999
SELECT *
  FROM ASSESSMENT_ANALYSIS;
  


-- Predict Performance

INSERT INTO assessment
VALUES (NULL, NULL, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'M', 2, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'M', 5, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'M', 5, 8);
INSERT INTO assessment
VALUES (NULL, NULL, 'F', 5, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'M', 2, 9);
INSERT INTO assessment
VALUES (NULL, NULL, 'M', 4, 10);
INSERT INTO assessment
VALUES (NULL, NULL, 'F', 5, 9);

COMMIT;

SET SERVEROUTPUT ON
DECLARE
   v_predict_accuracy NUMBER(10);
BEGIN
   DBMS_PREDICTIVE_ANALYTICS.PREDICT (
      v_predict_accuracy,
      'ASSESSMENT',
      'STUDENT_ID',
      'PERFORMANCE',
      'ASSESSMENT_PREDICTION');
      
   DBMS_OUTPUT.PUT_LINE('*** Accuracy ***');
   DBMS_OUTPUT.PUT_LINE(v_predict_accuracy);
END;
/

PROMPT ***
PROMPT *** Using DBMS_PREDICTIVE_ANALYTICS.PREDICT
PROMPT ***  Print the predicted performance of students
PROMPT ***  that have yet to complete the assessment
PROMPT ***
PROMPT

SELECT * FROM 
   ASSESSMENT_PREDICTION
   WHERE STUDENT_ID > 1024;

spool off