/*
 * diana_size.sql
 * Chapter 2, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script creates a package that retrieves the parsed size of a flattened diana AST
 */


CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

spool diana_size.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

CREATE OR REPLACE PACKAGE diana_size
AS
   PROCEDURE get_parsed_size(
      i_object_name IN VARCHAR2, 
      cv_result IN OUT SYS_REFCURSOR);
END diana_size;
/

CREATE OR REPLACE PACKAGE BODY diana_size
AS
   PROCEDURE get_parsed_size(
      i_object_name IN VARCHAR2,
      cv_result IN OUT SYS_REFCURSOR)
   IS
   BEGIN
      OPEN cv_result FOR
      SELECT name, type, parsed_size
      FROM user_object_size
      WHERE name = i_object_name;
  
   END get_parsed_size;
END;
/

spool off