/*
 * diana_size.sql
 * Chapter 2, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script prints the total UGA for your environment
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

spool diana_size.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

SELECT   SUBSTR (a.NAME, 9, 10) "Name",
            ROUND (SUM (b.VALUE) / 1024 / 1024,
                   1)
         || ' M' "Total UGA for all sessions"
    FROM v$statname a, v$sesstat b
   WHERE a.statistic# = b.statistic# AND a.NAME = 'session uga memory'
GROUP BY a.NAME;

spool off