/*
 * basic_error4.sql
 * Chapter 3, Oracle10g PL/SQL Programming
 * by Ron Hardman, Michael McLaughlin and Scott Urman
 *
 * This script raises and manages a standard anonymous block PL/SQL
 * program error.
 */

-- Unremark for debugging script.
-- SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

-- Build an anonymous block that will trigger an error.
DECLARE

  -- Define local exceptioon variable.
  my_error          EXCEPTION; 

BEGIN

  -- Raise the exception.
  RAISE my_error;
  
EXCEPTION

  WHEN others THEN
    dbms_output.put_line('RAISE my_error'||CHR(10)
                         ||'SQLCODE ['||SQLCODE||']'||CHR(10)
                         ||'SQLERRM ['||SQLERRM||']');

END;
/
