/*
 * create_definer1.sql
 * Chapter 4, Oracle Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script builds a definer's-rights package and grants
 * EXECUTE privileges to the MYAPP user.
 */

-- Unremark for debugging script.
-- SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

-- Create a DEFINER_RIGHTS package.
CREATE OR REPLACE PACKAGE definer_rights IS

  -- Define a GET_LITERAL function.
  FUNCTION get_literal
  ( literal VARCHAR2 )
  RETURN VARCHAR2;
  
END;
/

-- Create a DEFINER_RIGHTS package body.
CREATE OR REPLACE PACKAGE BODY definer_rights IS

  -- Define a GET_LITERAL function.
  FUNCTION get_literal
  ( literal VARCHAR2 )
  RETURN VARCHAR2 IS
  
  BEGIN

    -- Use an implicit for-loop to avoid declaring variables.
    FOR i IN (SELECT   literal
              FROM dual) LOOP
              
      -- Return the value.
      RETURN 'Called by ['||literal||']';
      
    END LOOP;

  END get_literal;
  
END definer_rights;
/

-- Grant EXECUTE privileges to MYAPP schema.
GRANT EXECUTE ON definer_rights TO myapp;
