/*
 * create_invoker_package.sql
 * Chapter 4, Oracle Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script creates a table and package to be used in
 * a code repository example of invoker's rights.
 */

-- Unremark for debugging script.
-- SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

-- Drop table if it exists.
DROP TABLE data_store;

-- Create local table.
CREATE TABLE data_store
( data_id       NUMBER
, data_text     VARCHAR2(20 CHAR));

-- Create the data management package.
CREATE OR REPLACE PACKAGE data_management
AUTHID CURRENT_USER AS

  -- Define the insert_data procedure.
  PROCEDURE insert_data
  ( data_id     NUMBER
  , data_text   VARCHAR2);

END data_management;
/

-- Create the data management package body.
CREATE OR REPLACE PACKAGE BODY data_management AS

  -- Implement the insert_data procedure.
  PROCEDURE insert_data
  ( data_id     NUMBER
  , data_text   VARCHAR2) IS

  BEGIN

    -- Insert into the table.
    INSERT
    INTO     data_store
    VALUES
    ( data_id
    , data_text );

  END insert_data;

END data_management;
/
