/*
 * demo_client_info1.sql
 * Chapter 4, Oracle Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script demonstrates DBMS_APPLICATION_INFO and its two
 * procedures. It should be run in the MYAPP user schema.
 */

-- Unremark for debugging script.
-- SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

-- Anonymous block program to demonstrate DBMS_APPLICATION_INFO package.
DECLARE

  -- Declare a test variable.
  my_env VARCHAR2(1);

BEGIN

  -- Read CLIENT_INFO into a variable.
  DBMS_APPLICATION_INFO.READ_CLIENT_INFO(my_env);

  -- Print the current value of CLIENT_INFO.
  DBMS_OUTPUT.PUT_LINE('Read CLIENT_INFO value ['||my_env||'].');

  -- Display message.
  DBMS_OUTPUT.PUT_LINE('Set CLIENT_INFO to     [1].');

  -- Set the value to one.
  DBMS_APPLICATION_INFO.SET_CLIENT_INFO('1');

  -- Read CLIENT_INFO into a variable.
  DBMS_APPLICATION_INFO.READ_CLIENT_INFO(my_env);

  -- Print the current value of CLIENT_INFO.
  DBMS_OUTPUT.PUT_LINE('Read CLIENT_INFO value ['||my_env||'].');

END;
/
