/*
 * HelloWorld3.java
 * Chapter 5, Oracle Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script builds an internal or server-side Java class file
 * that queries the local instance.
 */


// Oracle class imports.
import java.sql.*;
import oracle.jdbc.driver.*;

// Class definition.
public class HelloWorld3
{
  // Define the doDML() method.
  public static void doDML(String statement
                          ,String name) throws SQLException
  {
    // Define a connection for Oracle.
    Connection conn = new OracleDriver().defaultConnection();

    // Define and initialize a prepared statement.
    PreparedStatement ps = conn.prepareStatement(statement);

    // Assign the cursor return.
    ps.setString(1,name);
    ps.execute();

  } // End of the doDML() method.

  // --------------------------------------------/

  // Define the doDQL() method.
  public static String doDQL(String statement) throws SQLException
  {
    // Define and initialize a local return variable.
    String result = new String();

    // Define a connection for Oracle.
    Connection conn = new OracleDriver().defaultConnection();

    // Define and initialize a prepared statement.
    PreparedStatement ps = conn.prepareStatement(statement);

    // Execute a the query.
    ResultSet rs = ps.executeQuery();

    // Use a while-loop even though only one row is returned.
    while (rs.next())
    {
      // Assign the cursor return.
      result = rs.getString(1);
    }

    // Return the user name.
    return result;

  } // End of the doDQL() method.

} // End of HelloWorld3 class.
