/*
 * HelloWorld4.java
 * Chapter 5, Oracle Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script builds an internal or server-side Java class file
 * that is instantiable and queries the local instance for data.
 */


// Oracle class imports.
import java.sql.*;
import java.io.*;
import oracle.sql.*;
import oracle.jdbc.*;
import oracle.jdbc.oracore.*;

// Class definition.
public class HelloWorld4 implements SQLData
{
  // Define and initialize a private class name variable.
  private String className = new String("HelloWorld4.class");

  // Define a formal parameter signature variable.
  private String instanceName;

  // Define a private schema qualified name value.
  private String qualifiedName;

  // Define a class instance variable to support SQLData Interface.
  private String sql_type;

  // --------------------------------------------/

  // Define default constructor.
  public HelloWorld4()
  {
    // Define local String variables.
    String user = new String();

    // Use a try-catch block because of SQL statement.
    try
    {
      // Call a method of the inner class.
      user = getUserName();

    }
    catch (Exception e) {}

    // Set the class instance variable.
    qualifiedName = user + "." + className;

  } // End of default constructor.

  // --------------------------------------------/

  // Define a method to return a qualified name.
  public String getQualifiedName() throws SQLException
  {
    // Define and initialize a return variable.
    return this.qualifiedName + "." + instanceName;

  } // End of getQualifiedName() method.

  // --------------------------------------------/

  // Define a method to return the database object name.
  public String getSQLTypeName() throws SQLException
  {
    // Returns the UDT map value or database object name.
    return sql_type;

  } // End of getSQLTypeName() method.

  // --------------------------------------------/

  // Define getUserName() method to query the instance.
  public String getUserName() throws SQLException
  {
    // Define and initialize a local return variable.
    String userName = new String();

    // Define and initialize a query statement.
    String getDatabaseSQL = "SELECT user FROM dual";

    // Define a connection for Oracle.
    Connection conn = new OracleDriver().defaultConnection();

    // Define and initialize a prepared statement.
    PreparedStatement ps = conn.prepareStatement(getDatabaseSQL);

    // Execute a the query.
    ResultSet rs = ps.executeQuery();

    // Use a while-loop even though only one row is returned.
    while (rs.next())
    {
    // Assign the cursor return.
      userName = rs.getString(1);
    }

    // Return the user name.
    return userName;

  } // End of getUserName() method.

  // --------------------------------------------/

  // Implements readSQL() method from the SQLData interface.
  public void readSQL(SQLInput stream, String typeName) throws SQLException
  {
    // Define sql_type to read input and signal overloading signatures.
    sql_type = typeName;

    // Pass values into the class.
    instanceName = stream.readString();

  } // End of readSQL() method.

  // --------------------------------------------/

  // Implements readSQL() method from the SQLData interface.
  public void writeSQL(SQLOutput stream) throws SQLException
  {
    // You pass a value back by using a stream function.
    // stream.writeString('variable_name');

  } // End of readSQL() method.

} // End of HelloWorld4 class.
