/*
 * test_basic_object.sql
 * Chapter 6, Oracle Expert PL/SQL
 * by Ron Hardman and Michael McLaughlin
 *
 * This script tests sample object type.
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL test_basic_object1.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

SET SERVEROUTPUT ON SIZE 1000000

DECLARE

  -- Declare and initialize two instances.
  my_object_1 BUILD_TEST := build_test;
  my_object_2 BUILD_TEST := build_test(1);

BEGIN

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('=====================');

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('My Object 1 is:');
  DBMS_OUTPUT.PUT_LINE('---------------------');

  -- Call object method.
  my_object_1.print_instance_variable;

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('---------------------');
  DBMS_OUTPUT.PUT_LINE('My Object 2 is:');
  DBMS_OUTPUT.PUT_LINE('---------------------');

  -- Call object method.
  my_object_2.print_instance_variable;

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('---------------------');
  DBMS_OUTPUT.PUT_LINE('Test Object Equality:');
  DBMS_OUTPUT.PUT_LINE('---------------------');

  -- Use an if then else to audit equality.
  IF my_object_1 = my_object_2 THEN
    DBMS_OUTPUT.PUT_LINE('They are equal.');
  ELSE
    DBMS_OUTPUT.PUT_LINE('They are unequal.');
  END IF;

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('=====================');

END;
/

SPOOL OFF
