/*
 * test_sample_object2.sql
 * Chapter 6, Oracle Expert PL/SQL
 * by Ron Hardman and Michael McLaughlin
 *
 * This script tests the CONTACT_OBJECT object type.
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL test_sample_object2.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

SET SERVEROUTPUT ON SIZE 1000000

DECLARE

  -- Declare and initialize two instances.
  my_object_1 CONTACT_OBJECT := contact_object(
                                  'David'
                                 ,'Crocket'
                                 ,'1 Alamo Square'
                                 ,'San Antonio'
                                 ,'TX'
                                 ,'78202');
  my_object_2 CONTACT_OBJECT := contact_object(
                                  name_object('Santiago','Bowie')
                                 ,'1 Alamo Square'
                                 ,'San Antonio'
                                 ,'TX'
                                 ,'78202');

BEGIN

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('===============================');

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('My Object 1 is:');
  DBMS_OUTPUT.PUT_LINE('-------------------------------');

  -- Call object method.
  my_object_1.print_instance_variable;

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('-------------------------------');
  DBMS_OUTPUT.PUT_LINE('My Object 2 is:');
  DBMS_OUTPUT.PUT_LINE('-------------------------------');

  -- Call object method.
  my_object_2.print_instance_variable;

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('-------------------------------');
  DBMS_OUTPUT.PUT_LINE('Test Object Equality:');
  DBMS_OUTPUT.PUT_LINE('-------------------------------');

  -- Use an if then else to audit equality.
  IF my_object_1.equals(my_object_2) = 1 THEN
    DBMS_OUTPUT.PUT_LINE('They are equal.');
  ELSE
    DBMS_OUTPUT.PUT_LINE('They are unequal.');
  END IF;

  -- Print formatting header.
  DBMS_OUTPUT.PUT_LINE('===============================');

END;
/

SPOOL OFF
