/*
 * test_telephone_objects.sql
 * Chapter 6, Oracle Expert PL/SQL
 * by Ron Hardman and Michael McLaughlin
 *
 * This script demonstrates the collection object type
 * actually works.
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL test_telephone_objects.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

SET SERVEROUTPUT ON SIZE 1000000


-- Anonymous program to test the object type.
DECLARE

  -- Define a counter variable.
  c             NUMBER := 1;

  -- Define a TELEPHONE_OBJECT_TABLE collction variable.
  telephones    TELEPHONE_OBJECT_TABLE := telephone_object_table();

  -- Define a TELEPHONE_OBJECT_SET variable.
  telephone_set TELEPHONE_OBJECT_SET;

BEGIN

  -- Extend collection to add an element.
  telephones.EXTEND;

  -- Add an element.
  telephones(c) := TELEPHONE_OBJECT( 2001, 2001, 2001, 1006
                                    ,'001','650','555-7890');

  -- Demonstrate the telephone_object print method.
  telephones(c).print_telephone_number;

  -- Increment the counter.
  c := c + 1; 

  -- Extend collection to add an element.
  telephones.EXTEND;

  -- Add an element.
  telephones(c) := TELEPHONE_OBJECT( 2001, 2001, 2001, 1006
                                   ,'001','650','555-0987');

  -- Build a collection object with the constructor.
  telephone_set := telephone_object_set(telephones);

  -- Print message what is being done with the object.
  DBMS_OUTPUT.PUT_LINE('What is there after construction?');

  -- Print the contents of the collection object.
  telephone_set.print_telephone_object_set;

  -- Print message what is being done with the object.
  DBMS_OUTPUT.PUT_LINE('What is there after the add_set_member call?');

  -- Use the method to increment the collection object.
  telephone_set.add_set_member(
    TELEPHONE_OBJECT( 2001, 2001, 2001, 1006
                    ,'001','650','444-0987'));


  -- Print the contents of the collection object.
  telephone_set.print_telephone_number_set;

END;
/
