/*
 * create_thread_pipes.sql
 * Chapter 7, Oracle Expert PL/SQL
 * by Ron Hardman and Michael McLaughlin
 *
 * This script deletes pipes if it exists in the context of the current
 * session, then recreates them.
 */

SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

-- An anonymous block program to delete a pipe.
DECLARE

  retval INTEGER;
  
BEGIN

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_ABORT');

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_ABORT_LOCK');

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_COMMIT');

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_COMMIT_LOCK');

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_COMPLETE');

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_COMPLETE_LOCK');

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_REGISTER');

  -- Declare a variable by removing a pipe.
  retval := DBMS_PIPE.REMOVE_PIPE('PLSQL$THREAD_REGISTER_LOCK');

END;
/

-- An anonymous block program to create a pipe.
DECLARE

  -- Function output variable.
  retval INTEGER;

BEGIN

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_ABORT'
                                 , 20000 );

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_ABORT_LOCK'
                                 , 20000 );

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_COMMIT'
                                 , 20000 );

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_COMMIT_LOCK'
                                 , 20000 );

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_COMPLETE'
                                 , 20000 );

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_COMPLETE_LOCK'
                                 , 20000 );

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_REGISTER'
                                 , 20000 );

  -- Define a private pipe.
  retval := DBMS_PIPE.CREATE_PIPE('PLSQL$THREAD_REGISTER_LOCK'
                                 , 20000 );

  -- Print the retval status.
  IF (retval = 0) THEN
    DBMS_OUTPUT.PUT_LINE('THREAD_PIPES are created.');
  END IF;

EXCEPTION

  -- Raise generic exception.
  WHEN others THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    RETURN;

END;
/    

