/*
 * verify_threaded_execution.sql
 * Chapter 7, Oracle Expert PL/SQL
 * by Ron Hardman and Michael McLaughlin
 *
 * This script deletes pipes if it exists in the context of the current
 * session, then recreates them.
 */

SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

COL thread_id   FORMAT 9,999 HEADING 'Thread ID'
COL value_start FORMAT 9,999 HEADING 'Value|Start'
COL value_end   FORMAT 9,999 HEADING 'Value|End'
COL created     FORMAT A20   HEADING 'Created'
COL updated     FORMAT A20   HEADING 'Updated'

-- Check results of threaded submission.
SELECT   thread_id
,        value_start
,        value_end
,        TO_CHAR(date_created,'DD-MON-YY HH24:MI:SS') created
,        TO_CHAR(date_updated,'DD-MON-YY HH24:MI:SS') updated
FROM     thread
WHERE    thread_id BETWEEN  99 AND 102
OR       thread_id BETWEEN 199 AND 202
/