/*
 * gather_stats.sql
 * Chapter 8, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script gathers statistics for the PLSQL schema
 */

spool gather_stats.log

PROMPT ***
PROMPT *** Before gathering stats
PROMPT ***

COLUMN table_name FORMAT A15
COLUMN last_analyzed FORMAT A15
SELECT table_name, last_analyzed
FROM user_tables
WHERE table_name = 'PERSON';

PROMPT ***
PROMPT *** Gathering schema stats - this will take some time
PROMPT ***


EXEC DBMS_STATS.GATHER_SCHEMA_STATS('PLSQL')

PROMPT ***
PROMPT *** After gathering schema stats
PROMPT *** 

COLUMN table_name FORMAT A15
COLUMN last_analyzed FORMAT A15
SELECT table_name, last_analyzed
FROM user_tables
WHERE table_name = 'PERSON';

spool off