/*
 * queries.sql
 * Chapter 9, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script includes basic Text search SQL
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

spool queries.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

-- Basic CONTAINS query
SELECT score(1), title
FROM document_repository
WHERE CONTAINS(document, 'constitution', 1) > 0;

-- Basic CATSEARCH query
SELECT title, short_description
FROM document_repository
WHERE CATSEARCH(title, 'bill', null) > 0;

-- Search against concatenated datastore
SELECT score(1), title, short_description
FROM document_repository
WHERE CONTAINS(short_description, 'bill', 1) > 0;

-- Search of document themes using the ABOUT operator - the same
--  query without the ABOUT in it returns no rows...
SELECT SCORE(1) rank, title
FROM document_repository 
WHERE CONTAINS(document, 'ABOUT(United States Defense)', 1) > 0
ORDER BY 1 DESC;

-- Search an XML document using section searching and the WITHIN operator
SELECT SCORE(1) rank, title
FROM document_repository 
WHERE CONTAINS(xml_doc, 'President within TEXT', 1) > 0
ORDER BY 1 DESC;

spool off