/*
 * seed_data.sql
 * Chapter 9, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script includes basic Text search SQL
 */


CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

spool seed_data.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

exec clean_schema.tables;
exec clean_schema.ind;

CREATE TABLE document_repository (
   document_id NUMBER(10),
   title VARCHAR2(50 CHAR),
   short_description VARCHAR2(500 CHAR),
   document BFILE,
   xml_doc BFILE);

CREATE TABLE expert_gist (
   query_id NUMBER,
   pov VARCHAR2(80),
   gist CLOB);


CREATE TABLE expert_markup (
   query_id NUMBER,
   document CLOB);



INSERT INTO document_repository
VALUES (
   1, 
   'United States Constitution', 'The US Constitution was signed September 17, 1787, and ratified in 1789.  While it has had a number of amendments to it, it has served as the founding document to the United States.',
   BFILENAME('DOCUMENT_LOC', 'USConstitution.doc'),
   null); 

INSERT INTO document_repository
VALUES (
   2,
   'Bill of Rights',
   'The Bill of Rights are actually the first ten amendments to the constitution.  They are named the Bill of Rights because they address those rights that all free citizens of the United States have, and the government cannot take away.',
   BFILENAME('DOCUMENT_LOC', 'BillOfRights.doc'),
   null);

INSERT INTO document_repository
VALUES (
   3,
   'Amendments to the US Constitution',
   'The remaining Amendments to the US Constitution address a range of topics - from judicial power to the right to vote for all.',
   BFILENAME('DOCUMENT_LOC', 'Amendments.doc'),
   null);

INSERT INTO document_repository
VALUES (
   4, 
   'Oracle 10g PL/SQL Programming',
   'Oracle 10g PL/SQL Programming by Oracle Text takes the reader from beginning to advanced PL/SQL topics.',
   BFILENAME('DOCUMENT_LOC', 'PLSQLProgramming.pdf'),
   null);

INSERT INTO document_repository
VALUES (
   5,
   'Amendments XML File',
   'The remaining Amendments to the US Constitution address a range of topics - from judicial power to the right to vote for all.',
   null,
   BFILENAME('DOCUMENT_LOC', 'Amendments.xml'));

COMMIT;

spool off