/*
 * themes.sql
 * Chapter 9, Expert PL/SQL Programming
 * by Ron Hardman, Mike McLaughlin
 *
 * This script generates the themes of a document
 */


CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

spool themes.log

SET ECHO ON
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF

SET SERVEROUTPUT ON
DECLARE
   v_themes ctx_doc.theme_tab;
   v_rowid ROWID;
BEGIN

   SELECT rowid
   INTO v_rowid
   FROM document_repository
   WHERE document_id = 1;

   CTX_DOC.SET_KEY_TYPE('ROWID'); 

   CTX_DOC.THEMES('expert_idx', v_rowid, v_themes, num_themes =>10);

   DBMS_OUTPUT.PUT_LINE('       THEMES       ');
   DBMS_OUTPUT.PUT_LINE('====================');
   FOR c IN 1..v_themes.count
   LOOP
      DBMS_OUTPUT.PUT_LINE('Theme:  '||v_themes(c).theme);
      DBMS_OUTPUT.PUT_LINE('Weight: '||v_themes(c).weight);
      DBMS_OUTPUT.PUT_LINE('-');
END LOOP;
END;
/

spool off