/*
 * create_objects.sql
 * Chapter 10, Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script creates all utilities for chapter 10
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL create_objects.log

CREATE OR REPLACE PACKAGE handle_errors
IS

FUNCTION get_code (i_error_id IN NUMBER)
   RETURN VARCHAR2;

END;
/

CREATE OR REPLACE PACKAGE BODY handle_errors
IS
   FUNCTION get_code (i_error_id IN NUMBER)
      RETURN VARCHAR2
   IS
      v_string ERRORS.TEXT%TYPE;
   BEGIN
      SELECT text
      INTO v_string
      FROM errors
      WHERE error_id = i_error_id;
      
      RETURN v_string;
      
   EXCEPTION
      WHEN NO_DATA_FOUND
      THEN
         v_string := 'Invalid Error Code';
         RETURN v_string;
   END get_code;
END;
/

show errors