/*
 * seed_data.sql
 * Chapter 10, Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script adds seed data to the PLSQL user
 */

SPOOL seed_data.log

SET ECHO OFF
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF
SET ESCAPE \

EXEC clean_schema.tables

CREATE TABLE plants (
                     plant_id NUMBER(10) PRIMARY KEY,
                     formal_name VARCHAR2(100 CHAR),
                     common_name VARCHAR2(100 CHAR),
                     category VARCHAR2(50 CHAR),
                     family VARCHAR2(50 CHAR),
                     genus VARCHAR2(50 CHAR),
                     species VARCHAR2(50 CHAR),
                     entry_datetime TIMESTAMP);


INSERT INTO plants
VALUES (1, 'Celastrus scandens', 
        'American Bittersweet', 'VINES', 
        'Celastraceae', 'Celastrus',
        'Celastrus scandens', SYSTIMESTAMP);

INSERT INTO plants
VALUES (2, 'Clematis', 
        'Clematus', 'VINES', 
        'Ranunculaceae', 'Clematis',
        'Clematis', SYSTIMESTAMP);

INSERT INTO plants
VALUES (3, 'Clematis', 
        'Niobe Clematis', 'VINES', 
        'Ranunculaceae', 'Clematis',
        'Clematis', SYSTIMESTAMP);

INSERT INTO plants
VALUES (4, 'Clematis', 
        'Clematis', 'VINES', 
        'Ranunculaceae', 'Clematis',
        'Clematis', SYSTIMESTAMP);

INSERT INTO plants
VALUES (5, 'Clematis', 
        'Jackman Clematis', 'VINES', 
        'Ranunculaceae', 'Clematis',
        'Clematis', SYSTIMESTAMP);

INSERT INTO plants
VALUES (6, 'Clematis terniflora', 
        'Sweet Autumn Clematis', 'VINES', 
        'Ranunculaceae', 'Clematis',
        'Clematis terniflora', SYSTIMESTAMP);

INSERT INTO plants
VALUES (7, 'Clematis vitalba', 
        'Traveler''s Joy', 'VINES', 
        'Ranunculaceae', 'Clematis',
        'Clematis vitalba', SYSTIMESTAMP);

INSERT INTO plants
VALUES (8, 'Clerodendrum thomsoniae', 
        'Bleeding-heart Vine', 'VINES', 
        'Verbenaceae', 'Clerodendrum', 
        'Clerodendrum thomsoniae', SYSTIMESTAMP);

INSERT INTO plants
VALUES (9, 'Dolichos lablab', 
        'Lablab', 'VINES', 
        'Papilionaceae', 'Dolichos',
        'Dolichos lablab', SYSTIMESTAMP);

INSERT INTO plants
VALUES (10, 'Hydrangea anomala', 
        'Climbing Hydrangea', 'VINES', 
        'Hydrangeaceae', 'Hydrangea',
        'Hydrangea anomala', SYSTIMESTAMP);

INSERT INTO plants
VALUES (11, 'Ipomoea', 
        'Cardinal Climber', 'VINES', 
        'Convolvulaceae', 'Ipomoea',
        'Ipomoea', SYSTIMESTAMP);

INSERT INTO plants
VALUES (12, 'Ipomoea lobata', 
        'Spanish Flag', 'VINES', 
        'Convolvulaceae', 'Ipomoea',
        'Ipomoea', SYSTIMESTAMP);

INSERT INTO plants
VALUES (13, 'Ipomoea purpurea', 
        'Morning Glory', 'VINES', 
        'Convolvulaceae', 'Ipomoea',
        'Ipomoea', SYSTIMESTAMP);

INSERT INTO plants
VALUES (14, 'Lathyrus latifolius', 
        'Perennial Sweet Pea', 'VINES', 
        'Papilionaceae', 'Lathyrus',
        'Lathyrus latifolius', SYSTIMESTAMP);

INSERT INTO plants
VALUES (15, 'Lonicera japonica', 
        'Hall''s Japanese Honeysuckle', 'VINES', 
        'Caprifoliaceae', 'Lonicera',
        'Lonicera japonica', SYSTIMESTAMP);

INSERT INTO plants
VALUES (16, 'Mandevilla', 
        'Mandevilla Vine', 'VINES', 
        'Apocynaceae', 'Mandevilla',
        'Mandevilla', SYSTIMESTAMP);

INSERT INTO plants
VALUES (17, 'Mandevilla', 
        'Alice duPont Mandevilla Vine', 'VINES', 
        'Apocynaceae', 'Mandevilla',
        'Mandevilla', SYSTIMESTAMP);

INSERT INTO plants
VALUES (18, 'Parthenocissus quinquefolia', 
        'Virginia Creeper', 'VINES', 
        'Vitaceae', 'Parthenocissus',
        'Parthenocissus quinquefolia', SYSTIMESTAMP);

INSERT INTO plants
VALUES (19, 'Parthenocissus tricuspidata', 
        'Boston Ivy', 'VINES', 
        'Vitaceae', 'Parthenocissus',
        'Parthenocissus tricuspidata', SYSTIMESTAMP);

INSERT INTO plants
VALUES (20, 'Passiflora incarnata', 
        'Hardy Passionflower', 'VINES', 
        'Passifloraceae', 'Passiflora',
        'Passiflora incarnata', SYSTIMESTAMP);

INSERT INTO plants
VALUES (21, 'Polygonum aubertii', 
        'Silver Lace Vine', 'VINES', 
        'Polygonaceae', 'Polygonum',
        'Polygonum aubertii', SYSTIMESTAMP);

INSERT INTO plants
VALUES (22, 'Strongylodon macrobotrys', 
        'Jade Vine', 'VINES', 
        'Papilionaceae', 'Strongylodon',
        'Strongylodon macrobotrys', SYSTIMESTAMP);

INSERT INTO plants
VALUES (23, 'Thunbergia alata', 
        'Black-eyed Susan Vine ', 'VINES', 
        'Acanthaceae', 'Thunbergia',
        'Thunbergia alata', SYSTIMESTAMP);

INSERT INTO plants
VALUES (24, 'Thunbergia grandiflora', 
        'Sky Vine ', 'VINES', 
        'Acanthaceae', 'Thunbergia',
        'Thunbergia grandiflora', SYSTIMESTAMP);

INSERT INTO plants
VALUES (25, 'Wisteria', 
        'Wisteria', 'VINES', 
        'Papilionaceae', 'Wisteria',
        'Wisteria', SYSTIMESTAMP);

INSERT INTO plants
VALUES (26, 'Wisteria floribunda', 
        'White Japanese 	Wisteria', 'VINES', 
        'Papilionaceae', 'Wisteria',
        'Wisteria floribunda', SYSTIMESTAMP);

INSERT INTO plants
VALUES (27, 'Wisteria floribunda', 
        'Texas Purple Japanese Wisteria', 'VINES', 
        'Papilionaceae', 'Wisteria',
        'Wisteria floribunda', SYSTIMESTAMP);

INSERT INTO plants
VALUES (28, 'Wisteria sinensis', 
        'Chinese Wisteria', 'VINES', 
        'Papilionaceae', 'Wisteria',
        'Wisteria sinensis', SYSTIMESTAMP);

INSERT INTO plants
VALUES (29, 'Akebia quinata', 
        'Fiveleaf Akebia', 'VINES', 
        'Lardizabalaceae', 'Akebia', 
        'Akebia quinata', SYSTIMESTAMP);

INSERT INTO plants
VALUES (30, 'Ampelopsis brevipedunculata', 
        'Porcelain Berry', 'VINES', 
        'Vitaceae', 'Ampelopsis',
        'Ampelopsis brevipedunculata', SYSTIMESTAMP);

INSERT INTO plants
VALUES (31, 'Asarina scandens', 
        'Climbing Snapdragon', 'VINES', 
        'Scrophulariaceae', 'Asarina',
        'Asarina scandens', SYSTIMESTAMP);

INSERT INTO plants
VALUES (32, 'Campsis grandiflora', 
        'Chinese Trumpet Vine', 'VINES', 
        'Bignoniaceae', 'Campsis',
        'Campsis grandiflora', SYSTIMESTAMP);

INSERT INTO plants
VALUES (33, 'Campsis radicans', 
        'Trumpet Vine', 'VINES', 
        'Bignoniaceae', 'Campsis',
        'Campsis radicans', SYSTIMESTAMP);

INSERT INTO plants
VALUES (34, 'Celastrus orbiculatus', 
        'Chinese Bittersweet', 'VINES', 
        'Celastraceae', 'Celastrus',
        'Celastrus orbiculatus', SYSTIMESTAMP);

CREATE TABLE buyers (
                     buyer_id NUMBER(10) PRIMARY KEY,
                     first_name VARCHAR2(30 CHAR),
                     last_name VARCHAR2(30 CHAR),
                     email VARCHAR2(50 CHAR),
                     phone NUMBER(10));

INSERT INTO buyers
VALUES (1, 'Blenda', 'Packer', 'bpacker@plsqlbook.com', '1232343456');

INSERT INTO buyers
VALUES (2, 'June', 'Cloud', 'j_cloud@plsqlbook.com', '1928374650');

INSERT INTO buyers
VALUES (3, 'Patricia', 'Hardman', 'pat.hardman@plsqlbook.com', '4981237465');

INSERT INTO buyers
VALUES (4, 'Kevin', 'Cronk', 'kcronk@mail.plsqlbook.com', '8833992201');

INSERT INTO buyers
VALUES (5, 'Dave', 'Haehn', 'dave\&haehn@plsqlbook.com', '9871239812');

INSERT INTO buyers
VALUES (6, 'Scott', 'Eldridge', 'scott_e@PLSQLBOOK.COM', '3127774948');

INSERT INTO buyers
VALUES (7, 'Ruth', 'Henss', 'ruth@plsqlbook.com', '4465728367');

INSERT INTO buyers
VALUES (8, 'Shelley', 'Kooser', 'skooser@plsqlbook.com', '7193352278');

INSERT INTO buyers
VALUES (9, 'Judy', 'Zimmerman', 'zimm-judy@plsqlbook.com', '7193273948');

INSERT INTO buyers
VALUES (10, 'George', 'Hardman', 'ghard@mail.plsqlbook.com', '7193327658');

INSERT INTO buyers
VALUES (11, 'Tom', 'Doebler', 'drjonz@plsqlbook.com', '7193342556');

INSERT INTO buyers
VALUES (12, 'Roy', 'Stoddard', 'r(stoddard)@plsqlbook.com', '2239182736');

CREATE TABLE orders (
                     order_id NUMBER(10) PRIMARY KEY,
                     buyer_id NUMBER(10),
                     plant_id NUMBER(10),
                     order_date DATE);

INSERT INTO orders
VALUES (1, 2, 3, systimestamp);

INSERT INTO orders
VALUES (2, 4, 2, systimestamp);

INSERT INTO orders
VALUES (3, 12, 10, systimestamp);

INSERT INTO orders
VALUES (4, 5, 5, systimestamp);

INSERT INTO orders
VALUES (5, 3, 9, systimestamp);

CREATE TABLE errors (
   error_id NUMBER(10) PRIMARY KEY,
   text VARCHAR2(200 CHAR));
   
INSERT INTO errors
VALUES (1, 'Unless you operate under a completely separate set of internet rules than the rest of the world, the email address you provided is not valid');

INSERT INTO errors
VALUES (2, 'Um...I do believe you have supplied an invalid buyer_id');

CREATE TABLE web_pages (
   page_id NUMBER(10) PRIMARY KEY,
   page VARCHAR2(2000));
   
INSERT INTO web_pages
VALUES (1, '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html><head><title>html and regular expressions</title><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body>Expert PL/SQL</body></html>');

COMMIT;

SPOOL OFF

