 /*
 * sql_examples.sql
 * Chapter 10, Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script demonstrates the three regex functions and
 * one regex operator in basic sql statements.
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL sql_examples.log

SET ECHO OFF
SET HEAD OFF
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF
SET SERVEROUTPUT ON

@@seed_data.sql
@@create_objects.sql

SET FEEDBACK OFF

PROMPT ===================================
PROMPT === REGEXP_SUBSTR SQL Example 1 ===
PROMPT ===================================
COLUMN REGEXP_SUBSTR FORMAT A13
SELECT REGEXP_SUBSTR('The zip code 80831 is for Falcon, CO', '[[:digit:]]{5}') "REGEXP_SUBSTR"
FROM dual;
PROMPT -----------------------------------

PROMPT
PROMPT
PROMPT ===================================
PROMPT === REGEXP_SUBSTR SQL Example 2 ===
PROMPT ===================================
COLUMN REGEXP_SUBSTR FORMAT A13
SELECT REGEXP_SUBSTR('The zip code 80831 is for Falcon, CO', '[[:alpha:]]{3,}', 1, 3) "REGEXP_SUBSTR"
FROM dual;
PROMPT -----------------------------------

PROMPT
PROMPT
PROMPT ===================================
PROMPT === REGEXP_SUBSTR SQL Example 3 ===
PROMPT ===================================
COLUMN REGEXP_SUBSTR FORMAT A30
SELECT REGEXP_SUBSTR('Comments or questions - email feedback@plsqlbook.com',
   '[[:alnum:]](([_\.\-\+]?[[:alnum:]]+)*)@'
   ||'([[:alnum:]]+)(([\.-]?[[:alnum:]]+)*)\.([[:alpha:]]{2,})') "REGEXP_SUBSTR"
FROM dual;
PROMPT -----------------------------------


PROMPT
PROMPT 
PROMPT ================================
PROMPT === REGEXP_INSTR SQL Example ===
PROMPT ================================
SELECT REGEXP_INSTR('The zip code 80831 is for Falcon, CO', '[[:digit:]]{5}') "REGEXP_INSTR"
FROM dual;
PROMPT --------------------------------


PROMPT
PROMPT
PROMPT ===========================================
PROMPT ===     REGEXP_REPLACE SQL Example      ===
PROMPT === The original number is 719-111-1111 ===
PROMPT ===========================================
COLUMN REGEXP_REPLACE FORMAT A50
SELECT REGEXP_REPLACE('Reformat the phone number 719-111-1111 ...',
          '[1]?[- .]?(\(?[[:digit:]]{3}\)?)+[- .]?'
          ||'([[:digit:]]{3})[- .]?([[:digit:]]{4})',
          ' (\1) \2-\3') "REGEXP_REPLACE"
FROM dual;
PROMPT -------------------------------------------


PROMPT
PROMPT
PROMPT ===============================
PROMPT === REGEXP_LIKE SQL Example ===
PROMPT ===============================
COLUMN common_name FORMAT A30
COLUMN species FORMAT A30
SET PAGES 9999
SELECT common_name, species
FROM plants
WHERE REGEXP_LIKE (species,
           'parthenocissus (quinquefolia|tricuspidata)', 'i');
PROMPT -------------------------------

           
spool off
SET FEEDBACK ON
SET HEAD ON