/*
 * web_page_extract.sql
 * Chapter 10, Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script demonstrates how regular expressions can be used
 *  to extract text based on specific tags.
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL triggers.log

SET ECHO OFF
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF
SET SERVEROUTPUT ON

@@seed_data.sql
@@create_objects.sql

CREATE OR REPLACE PROCEDURE html_extract (
   p_tag IN VARCHAR2)
IS   
 
   CURSOR section_cur IS
      SELECT REGEXP_SUBSTR(page, '<'
         ||p_tag||'>(.*?)</'
         ||p_tag||'>', 1, 1, 'i') AS "TAG_TEXT"
      FROM web_pages;
      
BEGIN

   FOR text IN section_cur
   LOOP
      DBMS_OUTPUT.PUT_LINE(text.tag_text);
   END LOOP;
END;
/

PROMPT
PROMPT
PROMPT ===========================================
PROMPT === Returns all text between TITLE tags ===
PROMPT ===========================================

EXEC html_extract('title')


PROMPT
PROMPT
PROMPT ==========================================
PROMPT === Returns all text between BODY tags ===
PROMPT ==========================================

EXEC html_extract('body')