/*
 * create_helloworld1.sql
 * Chapter 11, Oracle Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script builds a procedure to render a dynamic web page.
 */

-- Unremark for debugging script.
-- SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

-- Create a PL/SQL Toolkit generated webpage.
CREATE OR REPLACE PROCEDURE HelloWorldProcedure1 AS

BEGIN

  -- Set a HTML META tag.
  owa_util.mime_header('text/html');  -- <META Content-type:text/html>

  -- Set HTML page rendering tags.
  htp.htmlopen;                       -- <HTML>
  htp.headopen;                       -- <HEAD>
  htp.htitle('HelloWorldProcedure1'); -- <TITLE>HelloWorldProcedure</TITLE>
  htp.headclose;                      -- </HEAD>
  htp.bodyopen;                       -- <BODY>
  htp.line;                           -- <HR>
  htp.print('Hello world.');          -- Hello world.
  htp.line;                           -- <HR>
  htp.bodyclose;                      -- </BODY>
  htp.htmlclose;                      -- </HTML>
 
END HelloWorldProcedure1;
/
