 /*
 * dbms_file_transfer.sql
 * Chapter 12, Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script demonstrates how the DBMS_FILE_TRANSFER package
 *  can be used to copy files on a local file server from within the db
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL dbms_file_transfer.log

SET ECHO OFF
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF
SET SERVEROUTPUT ON

-- COPY_FILE
BEGIN
  DBMS_FILE_TRANSFER.COPY_FILE (
                                source_directory_object => 'IMAGE_DIR',
                                source_file_name => 'File_Transfer.txt',
                                destination_directory_object => 'IMAGE_DIR',
                                destination_file_name => 'File_Transfer_Copy.txt');
END;
/

SPOOL OFF