 /*
 * dbms_stats.sql
 * Chapter 12, Expert PL/SQL Programming
 * by Ron Hardman and Michael McLaughlin
 *
 * This script demonstrates how DBMS_STATS can assist in troubleshooting
 *  performance issues
 */

CLEAR BREAKS
CLEAR COLUMNS
CLEAR COMPUTES

TTITLE OFF

SPOOL dbms_stats.log

SET ECHO OFF
SET FEEDBACK ON
SET NULL '<Null>'
SET PAGESIZE 999
SET PAUSE OFF
SET TERM ON
SET TIME OFF
SET TIMING OFF
SET VERIFY OFF
SET SERVEROUTPUT ON

PROMPT
PROMPT Running Gather Schema Statistics...
PROMPT

BEGIN
   DBMS_STATS.GATHER_SCHEMA_STATS('PLSQL', 10);
END;
/

PROMPT
PROMPT Creating a table to hold statistics...
PROMPT

BEGIN
   DBMS_STATS.CREATE_STAT_TABLE(null, 
                                'STATISTICS', 
                                null);
END;
/

PROMPT
PROMPT Exporting statistics for the PLSQL schema to the STATISTICS table...
PROMPT

BEGIN
   DBMS_STATS.EXPORT_SCHEMA_STATS ('PLSQL', 
                                   'STATISTICS', 
                                    NULL, NULL);
END;
/

PROMPT 
PROMPT Export the statistics table
PROMPT 
PROMPT $ exp userid=plsql/oracle tables=STATISTICS \
PROMPT > file=statistics.dmp log=statistics_export.log
PROMPT
PROMPT Import the statistics into the destination table
PROMPT
PROMPT $ imp userid=plsql/oracle tables=STATISTICS file=statistics.dmp \
PROMPT > log=statistics_import.log ignore=y
PROMPT
PROMPT
PROMPT *** SHOULD BE RUN IN YOUR DESTINATION INSTANCE ***
PROMPT
PROMPT BEGIN
PROMPT    DBMS_STATS.IMPORT_SCHEMA_STATS (
PROMPT       'PLSQL2',
PROMPT       'STATISTICS',
PROMPT       NULL, NULL, NULL, NULL);
PROMPT END;
PROMPT /
PROMPT




SPOOL OFF